<?php

namespace NoccyLabs\React\Http\Middleware;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use React\Http\Message\Response;
use React\Promise\PromiseInterface;

class ErrorHandlingMiddleware
{
    public function __construct(private bool $debug = false)
    {
        
    }

    public function __invoke(ServerRequestInterface $request, ?callable $next = null): ResponseInterface|PromiseInterface
    {
        try {
            return $next($request);
        } catch (\Throwable $t) {
            if ($this->debug)
                return Response::plaintext((string)$t)->withStatus(500);
            return Response::plaintext("HTTP 500")->withStatus(500);
        }
    }
}