<?php

namespace NoccyLabs\React\Http\Middleware;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use React\Http\Message\Response;
use NoccyLabs\React\Http\Session\SessionManager;
use NoccyLabs\React\Http\Security\SecurityException;
use NoccyLabs\React\Http\Security\UserManagerInterface;
use NoccyLabs\React\Http\Session\SessionManagerInterface;
use React\Promise\PromiseInterface;

class SessionMiddleware
{
    public function __construct(
        private SessionManagerInterface $sessionManager,
    )
    {
    }

    public function __invoke(ServerRequestInterface $request, ?callable $next = null): ResponseInterface|PromiseInterface
    {
        foreach ($request->getHeader("cookie") as $cookie) {
            $jar = explode("; ",$cookie);
            foreach ($jar as $str) {
                if (str_starts_with($str, "sid=")) {
                    $sessionId = substr($str, 4);
                }
            }
        }

        if (isset($sessionId)) {
            $session = $this->sessionManager->getSession($sessionId);
        } else {
            $session = $this->sessionManager->createSession();
        }

        $response = $next(
            $request
                ->withAttribute("session", $session)
                ->withAttribute("session_id", $session->getId())
        );

        if ($response instanceof ResponseInterface) {
            return $response
                ->withAddedHeader("set-Cookie", "sid={$session->getId()}; Path=/");
        }
        return $response;
    }

}
