<?php

namespace NoccyLabs\React\Http\Attributes;

use PHPUnit\Framework\Attributes\CoversClass;
use React\Http\Message\ServerRequest;

#[CoversClass(Route::class)]
class RouteTest extends \PHPUnit\Framework\TestCase
{
    
    public function testParsingVariablesFromPaths()
    {
        $route = new Route("/");
        $this->assertTrue($route->matches(new ServerRequest("GET", "/")));
        $this->assertFalse($route->matches(new ServerRequest("GET", "/test")));

        $route = new Route("/:foo");
        $this->assertFalse($route->matches(new ServerRequest("GET", "/")));
        $this->assertTrue($route->matches(new ServerRequest("GET", "/test")));
        $this->assertEquals([ 'foo'=>'test'], $route->resolve(new ServerRequest("GET", "/test")));

        $route = new Route("/:foo/bar");
        $this->assertFalse($route->matches(new ServerRequest("GET", "/")));
        $this->assertTrue($route->matches(new ServerRequest("GET", "/test/bar")));
        $this->assertEquals([ 'foo'=>'test'], $route->resolve(new ServerRequest("GET", "/test/bar")));

    }
}
