<?php

namespace NoccyLabs\React\Http\Handler;

use NoccyLabs\React\Http\Attributes\Route;
use PHPUnit\Framework\Attributes\CoversClass;
use Psr\Http\Message\ServerRequestInterface;
use React\Http\Message\Response;
use React\Http\Message\ServerRequest;

#[CoversClass(RequestHandler::class)]
class RequestHandlerTest extends \PHPUnit\Framework\TestCase
{
    
    public function testRequestsAreHandled()
    {

        $request = new ServerRequest("GET", "/", serverParams:['REMOTE_ADDR'=>"127.0.0.1"]);

        $handler = function (ServerRequestInterface $request) {
            return Response::plaintext("routed");
        };

        $request = $request
            ->withAttribute("route", new Route("/"))
            ->withAttribute("handler", $handler)
            ->withAttribute("route-data", []);

        $handler = new RequestHandler();

        $response = $handler($request);

        $this->assertEquals(200, $response->getStatusCode());
        $this->assertEquals("routed", $response->getBody()->getContents());

    }
}