<?php

namespace NoccyLabs\React\Http\Handler;

use PHPUnit\Framework\Attributes\CoversClass;
use React\Http\Message\ServerRequest;

#[CoversClass(StaticHandler::class)]
class StaticHandlerTest extends \PHPUnit\Framework\TestCase
{
    public function testFetchingStaticContent()
    {
        $handler = new StaticHandler(dirname(__DIR__)."/_root");
        $request = new ServerRequest("GET", "/file.txt");
        $response = $handler($request);

        $this->assertEquals(200, $response->getStatusCode());
        $this->assertEquals("text/plain", $response->getHeaderLine("Content-Type"));
    }

    public function testFetchingMissingContentFails()
    {
        $handler = new StaticHandler(dirname(__DIR__)."/_root");
        $request = new ServerRequest("GET", "/file.html");
        $response = $handler($request);

        $this->assertEquals(404, $response->getStatusCode());
    }

}