<?php

namespace NoccyLabs\React\Http\Middleware;

use PHPUnit\Framework\Attributes\CoversClass;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use React\Http\Message\Response;
use React\Http\Message\ServerRequest;

#[CoversClass(ErrorHandlingMiddleware::class)]
class ErrorHandlingMiddlewareTest extends \PHPUnit\Framework\TestCase
{
    
    public function testSuccessfulRequests()
    {
        $middleware = new ErrorHandlingMiddleware();

        $request = new ServerRequest("GET", "/");

        $handler = function (ServerRequestInterface $request) {
            return new Response();
        };

        $response = $middleware($request, $handler);

        $this->assertInstanceOf(ResponseInterface::class, $response);
        $this->assertEquals(200, $response->getStatusCode());
    }

    public function testFailingRequests()
    {
        $middleware = new ErrorHandlingMiddleware();

        $request = new ServerRequest("GET", "/");

        $handler = function (ServerRequestInterface $request) {
            throw new \RuntimeException();
        };

        $response = $middleware($request, $handler);
        
        $this->assertInstanceOf(ResponseInterface::class, $response);
        $this->assertEquals(500, $response->getStatusCode());        
    }

}