<?php

namespace NoccyLabs\React\Http\Middleware;

use NoccyLabs\React\Http\Session\SessionInterface;
use NoccyLabs\React\Http\Session\SessionManager;
use PHPUnit\Framework\Attributes\CoversClass;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Log\LoggerInterface;
use Psr\Log\LoggerTrait;
use React\Http\Message\Response;
use React\Http\Message\ServerRequest;
use Stringable;

#[CoversClass(SessionMiddleware::class)]
class SessionMiddlewareTest extends \PHPUnit\Framework\TestCase
{
    
    public function testSessionsAreCreated()
    {
        $logger = new class implements LoggerInterface {
            use LoggerTrait;
            public function log($level, string|Stringable $message, array $context = []): void
            {      
            }
        };

        $sessions = new SessionManager($logger);
        $middleware = new SessionMiddleware($sessions);

        $request = new ServerRequest("GET", "/", serverParams:['REMOTE_ADDR'=>"127.0.0.1"]);

        /** @var ServerRequestInterface|null */
        $receivedRequest = null;

        $handler = function (ServerRequestInterface $request) use (&$receivedRequest) {
            $receivedRequest = $request;
            return new Response();
        };

        $response = $middleware($request, $handler);

        $this->assertInstanceOf(SessionInterface::class, $receivedRequest->getAttribute("session"));
    }

}
