<?php

namespace NoccyLabs\React\Http\Routing;

use NoccyLabs\React\Http\Attributes\Route;
use PHPUnit\Framework\Attributes\CoversClass;
use Psr\Http\Message\ServerRequestInterface;
use React\Http\Message\ServerRequest;

#[CoversClass(RouteCollection::class)]
class RouteCollectionTest extends \PHPUnit\Framework\TestCase
{
    
    public function testMatchingRoutes()
    {
        $collection = new RouteCollection();
        $collection->addRoute(new Route("/"), "foobar");

        $matched = $collection->matchRoute(new ServerRequest("GET", "/"));

        $this->assertInstanceOf(Route::class, $matched->getAttribute("route"));
        $this->assertEquals("foobar", $matched->getAttribute("handler"));
        $this->assertIsArray($matched->getAttribute("route-data"));
    }
}